module Rateme
  module Macros
    extend ActiveSupport::Concern

    included do
    end

    module ClassMethods
      def rateme(options = {})
        include RequiredMethods

        has_many :ratings, :as => :rateable

        cattr_accessor :minimum_rating_allowed
        cattr_accessor :maximum_rating_allowed

        self.minimum_rating_allowed = options[:from] || 1
        self.maximum_rating_allowed = options[:upto] || 5
      end
    end

    module RequiredMethods
      def rating
        if (rating = ratings.average(:value))
          rating 
        else                     
          0.to_f                           
        end                                      
      end

      def rate(value, options = {})
        ratings.create(options.merge({ :value => value }))
      end

      def rating_range
        minimum_rating_allowed..maximum_rating_allowed
      end
    end
  end
end

